<template>
    <div class="form">
        <div @keydown="clear">
            <div class="form-group">
                <label for="title">Title</label>
                <input type="text" class="form-control" id="title" placeholder="Title" v-model="form.title">
                <div class="alert alert-danger" v-if="form.errors.has('title')" v-text="form.errors.get('title')"></div>
            </div>
            <div class="form-group">
                <label for="description">Description</label>
                <textarea type="text" class="form-control" id="description" placeholder="1234 Main St"
                          v-model="form.description"/>
                <div class="alert alert-danger" v-if="form.errors.has('description')"
                     v-text="form.errors.get('description')"></div>
            </div>
            <div class="form-group">
                <label for="address">Address</label>
                <input type="text" class="form-control" id="address" placeholder="Apartment, studio, or floor"
                       v-model="form.address">
                <div class="alert alert-danger" v-if="form.errors.has('address')"
                     v-text="form.errors.get('address')"></div>
            </div>
            <div class="form-row">
                <div class="form-group col-md-6">
                    <label for="rooms">Rooms</label>
                    <input type="number" class="form-control" id="rooms" placeholder="2" v-model="form.rooms">
                    <div class="alert alert-danger" v-if="form.errors.has('rooms')"
                         v-text="form.errors.get('rooms')"></div>
                </div>
                <div class="form-group col-md-6">
                    <label for="price">Price</label>
                    <input type="number" class="form-control" id="price" placeholder="20000" v-model="form.price">
                    <div class="alert alert-danger" v-if="form.errors.has('price')"
                         v-text="form.errors.get('price')"></div>
                </div>
            </div>
            <button type="submit" class="btn btn-primary" :disabled="form.errors.any()" @click="submit">Submit</button>
        </div>
    </div>
</template>

<script>
    import {mapGetters, mapState} from "vuex";
    import Form from 'form-backend-validation';
    export default {
        name: "AddListing",
        data() {
            return {
                form: new Form({
                    title: '',
                    description: '',
                    address: '',
                    rooms: '',
                    price: '',
                }, {
                    resetOnSuccess: false,
                    http: this.$http,
                }),
            };
        },
        mounted() {
        },
        computed: {
            ...mapState({

            }),
            ...mapGetters([
                'user',
            ])
        },
        methods: {
            clear() {
                this.form.errors.clear()
            },
            submit() {
                this.$store.dispatch('addListing', this.form).then(response => this.onAddSuccess(response)).catch(response => this.onError(response));
            },
            onSuccess(response) {

            },
            onAddSuccess(response) {
                this.$router.push('/')
            },
            onError(response) {
                console.log(response)
            },
        },
        props: {
            //listing: {required: true, va},
        }
    }
</script>

<style scoped>
    .form {
        margin-left: 150px;
        margin-right: 150px;
    }
</style>
